-- convert binary to bcd
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.add3f.all;

entity dec2bcd is
	port(
		int : in  std_logic_vector(5 downto 0);
		bcd : out std_logic_vector(7 downto 0)
	);
end dec2bcd;

-- See: https://en.wikipedia.org/wiki/Double_dabble#VHDL_implementation
architecture proc of dec2bcd is
begin
	process(int)
		variable temp    : std_logic_vector(5 downto 0);
		variable bcd_tmp : unsigned(7 downto 0) := (others => '0');
	begin
		bcd_tmp := (others => '0');
		temp    := int;
		for i in 0 to 5 loop
			bcd_tmp(3 downto 0)   := add3(bcd_tmp(3 downto 0));
			bcd_tmp(7 downto 4)   := add3(bcd_tmp(7 downto 4));

			bcd_tmp := bcd_tmp(6 downto 0) & temp(5);
			temp    := std_logic_vector(temp(4 downto 0) & '0');
		end loop;
		bcd <= std_logic_vector(bcd_tmp);
	end process;
end; 
